/*!
 * UI development toolkit for HTML5 (OpenUI5)
 * (c) Copyright 2009-2016 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.define([],function(){"use strict";var s,r=/^(?:[=(),;*]|\$expand|\$select|([a-zA-Z_\u0080-\uFFFF][/\w\u0080-\uFFFF]*))/,P;s={"$expand":{nud:function(T,o){var E={},b,q,Q,v;o.advance("=");do{v=null;b=o.advance("PATH").value;if(o.advanceIf("(")){v={};do{q=o.systemQueryOption(0);Q=Object.keys(q)[0];v[Q]=q[Q];}while(o.advanceIf(";"));o.advance(")");}E[b]=v;}while(o.advanceIf(","));return{"$expand":E};}},"$select":{nud:function(T,o){var S=[];o.advance("=");if(o.advanceIf("*")){return{"$select":["*"]};}do{S.push(o.advance("PATH").value);}while(o.advanceIf(","));return{"$select":S};}},"PATH":{nud:a},"*":{nud:a},"=":{nud:a},",":{nud:a},";":{nud:a},"(":{nud:a},")":{nud:a}};function e(w,T){if(!T){throw new SyntaxError("Expected "+w+" but instead saw end of input");}throw new SyntaxError("Expected "+w+" but instead saw '"+T.value+"' at "+T.at);}function a(T){e("option",T);}function p(T){var c=0,R,o;function b(E){var o=T[c];if(E&&(!o||o.id!==E)){e("'"+E+"'",o);}c+=1;return o;}function d(E){var o=T[c];if(o&&o.id===E){c+=1;return true;}return false;}function f(g){var l,h={advance:b,advanceIf:d,systemQueryOption:f};o=b();if(!o){throw new SyntaxError("Expected option but instead saw end of input");}l=s[o.id].nud(o,h);return l;}R=f(0);if(c<T.length){e("end of input",T[c]);}return R;}function t(o){var A=0,m,T,b=[];while(o.length){m=r.exec(o);if(m){T={at:A,id:m[1]?"PATH":m[0],value:m[0]};}else{throw new SyntaxError("Unknown character '"+o[0]+"' at "+A);}o=o.slice(m[0].length);A+=m[0].length;b.push(T);}return b;}P={parseSystemQueryOption:function(o){return p(t(o));}};return P;},false);
